# nxos_vpc – Manages global VPC configuration

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Manages global VPC configuration

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---

auto_recovery
boolean

Choices:
- no
- yes

Enables/Disables auto recovery on platforms that support disable
timers are not modifiable with this attribute
mutually exclusive with auto_recovery_reload_delay

auto_recovery_reload_delay string added in 2.9 |  | Manages auto-recovery reload-delay timer in seconds mutually exclusive with auto_recovery
delay_restore string |  | manages delay restore command and config value in seconds
delay_restore_interface_vlan string added in 2.9 |  | manages delay restore interface-vlan command and config value in seconds not supported on all platforms
delay_restore_orphan_port string added in 2.9 |  | manages delay restore orphan-port command and config value in seconds not supported on all platforms
domain - / required |  | VPC domain

peer_gw
boolean

Choices:
- no
- yes

Enables/Disables peer gateway

pkl_dest - |  | Destination (remote) IP address used for peer keepalive link pkl_dest is required whenever pkl options are used.
pkl_src - |  | Source IP address used for peer keepalive link
pkl_vrf - | Default: "management" | VRF used for peer keepalive link The VRF must exist on the device before using pkl_vrf. (Note) 'default' is an overloaded term: Default vrf context for pkl_vrf is 'management'; 'pkl_vrf: default' refers to the literal 'default' rib.

provider
dictionary

Deprecated
Starting with Ansible 2.5 we recommend using `connection: network_cli`.
This option is only required if you are using NX-API.
For more information please see the NXOS Platform Options guide.

A dict object containing connection details.

| auth_pass string added in 2.5.3 |  | Specifies the password to use if required to enter privileged mode on the remote device. If authorize is false, then this argument does nothing. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTH_PASS` will be used instead.

authorize
boolean
added in 2.5.3

Choices:
- no ←
- yes

Instructs the module to enter privileged mode on the remote device before sending any commands. If not specified, the device will attempt to execute all commands in non-privileged mode. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_AUTHORIZE` will be used instead.

| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This is a common argument used for either cli or nxapi transports. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: "0 (use common port)" | Specifies the port to use when building the connection to the remote device. This value applies to either cli or nxapi. The port value will default to the appropriate transport common port if none is provided in the task. (cli=22, http=80, https=443).
| ssh_keyfile string |  | Specifies the SSH key to use to authenticate the connection to the remote device. This argument is only used for the cli transport. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error. NX-API can be slow to return on long-running commands (sh mac, sh bgp, etc).

transport
string / required

Choices:
- cli ←
- nxapi

Configures the transport connection to use when connecting to the remote device. The transport argument supports connectivity to the device over cli (ssh) or nxapi.

use_proxy
boolean
added in 2.5

Choices:
- no
- yes ←

If `no`, the environment variables `http_proxy` and `https_proxy` will be ignored.

use_ssl
boolean

Choices:
- no ←
- yes

Configures the transport to use SSL if set to `yes` only when the `transport=nxapi`, otherwise this value is ignored.

| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate either the CLI login or the nxapi authentication depending on which transport is used. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.

validate_certs
boolean

Choices:
- no
- yes ←

If `no`, SSL certificates will not be validated. This should only be used on personally controlled sites using self-signed certificates. If the transport argument is not nxapi, this value is ignored.

role_priority - |  | Role priority for device. Remember lower is better.

state
- / required

Choices:
- present
- absent

Manages desired state of the resource

system_priority - |  | System priority device. Remember they must match between peers.

## Notes

Note

- Tested against NXOSv 7.3.(0)D1(1) on VIRL
- The feature vpc must be enabled before this module can be used
- If not using management vrf, vrf must be globally on the device before using in the pkl config
- Although source IP isn’t required on the command line it is required when using this module. The PKL VRF must also be configured prior to using this module.
- Both pkl_src and pkl_dest are needed when changing PKL VRF.
- For information on using CLI and NX-API see the NXOS Platform Options guide
- For more information on using Ansible to manage network devices see the Ansible Network Guide
- For more information on using Ansible to manage Cisco devices see the Cisco integration page.

## Examples

    - name: configure a simple asn
      nxos_vpc:
        domain: 100
        role_priority: 1000
        system_priority: 2000
        pkl_dest: 192.168.100.4
        pkl_src: 10.1.100.20
        peer_gw: true
        auto_recovery: true

    - name: configure
      nxos_vpc:
        domain: 100
        role_priority: 32667
        system_priority: 2000
        peer_gw: true
        pkl_src: 10.1.100.2
        pkl_dest: 192.168.100.4
        auto_recovery: true

    - name: Configure VPC with delay restore and existing keepalive VRF
      nxos_vpc:
        domain: 10
        role_priority: 28672
        system_priority: 2000
        delay_restore: 180
        peer_gw: true
        pkl_src: 1.1.1.2
        pkl_dest: 1.1.1.1
        pkl_vrf: vpckeepalive
        auto_recovery: true

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
commands list | always | commands sent to the device Sample: ['vpc domain 100', 'peer-keepalive destination 192.168.100.4 source 10.1.100.20 vrf management', 'auto-recovery', 'peer-gateway']

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Jason Edelman (@jedelman8)
- Gabriele Gerbino (@GGabriele)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.